-- author: rafftnix
-- date: 24.11.2012

ExternalAccountEvent = {};
ExternalAccountEvent_mt = Class(ExternalAccountEvent, Event);
InitEventClass(ExternalAccountEvent, "ExternalAccountEvent");

function ExternalAccountEvent:emptyNew()
    local self = Event:new(ExternalAccountEvent_mt);
    return self;
end;

function ExternalAccountEvent:new(userId, money)
    local self = ExternalAccountEvent:emptyNew(); 
    self.userId = userId; 
	self.money = money;
    return self;
end;

function ExternalAccountEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, math.floor(self.money));
    streamWriteInt8(streamId, self.userId);
end;

function ExternalAccountEvent:readStream(streamId, connection)
    self.money = streamReadInt32(streamId);
    self.userId = streamReadInt8(streamId);
    self:run(connection);
end;

function ExternalAccountEvent:run(connection)
	ExternalAccount:moneyReceived(self.userId, self.money);
	if not connection:getIsServer() then
		g_server:broadcastEvent(ExternalAccountEvent:new(self.userId, self.money), nil, connection, nil);
	end; 
end;

function ExternalAccountEvent.sendEvent(object, userId, money)
	if g_server ~= nil then   
		g_server:broadcastEvent(ExternalAccountEvent:new(userId, money), nil, nil, nil); 
	else  
		g_client:getServerConnection():sendEvent(ExternalAccountEvent:new(userId, money)); 
	end;
end;